var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

import React from 'react';
import classNames from 'classnames';
import PropTypes from 'prop-types';

import { submitEvent } from '../eventWrappers';
import { getNodeRenderOptions, updateNode } from '../selectors/nodes';
import { Renderer } from '../shapes/rendererShapes';

var Expandable = function Expandable(_ref) {
  var onChange = _ref.onChange,
      node = _ref.node,
      children = _ref.children,
      index = _ref.index,
      _ref$icons = _ref.icons,
      icons = _ref$icons === undefined ? {
    expanded: React.createElement('i', { className: 'mi mi-keyboard-arrow-down' }),
    collapsed: React.createElement('i', { className: 'mi mi-keyboard-arrow-right' }),
    blank: null
  } : _ref$icons,
      _ref$isFolder = _ref.isFolder,
      isFolder = _ref$isFolder === undefined ? function (node) {
    return !!node.children;
  } : _ref$isFolder;

  var _getNodeRenderOptions = getNodeRenderOptions(node),
      isExpanded = _getNodeRenderOptions.isExpanded;

  var hasChildren = isFolder(node);

  var icon = null;
  if (hasChildren && isExpanded) {
    icon = icons.expanded;
  } else if (hasChildren && !isExpanded) {
    icon = icons.collapsed;
  } else {
    icon = icons.blank;
  }

  var handleChange = function handleChange() {
    onChange(_extends({}, updateNode(node, { expanded: !isExpanded }), { index: index }));
  };

  return React.createElement(
    'span',
    { className: 'tree-expandable', onDoubleClick: handleChange, onClick: handleChange },
    hasChildren && React.createElement(
      'span',
      { className: 'tree-expandable-icon' },
      React.createElement(
        'span',
        { tabIndex: 0 },
        icon
      )
    ),
    React.createElement(
      'span',
      { className: 'tree-expandable-info' },
      children
    )
  );
};

Expandable.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, Renderer, {
  iconsClassNameMap: PropTypes.shape({
    expanded: PropTypes.string,
    collapsed: PropTypes.string,
    lastChild: PropTypes.string
  })
}) : {};

export default Expandable;