'use strict';

exports.__esModule = true;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _eventWrappers = require('../eventWrappers');

var _nodes = require('../selectors/nodes');

var _rendererShapes = require('../shapes/rendererShapes');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Expandable = function Expandable(_ref) {
  var onChange = _ref.onChange,
      node = _ref.node,
      children = _ref.children,
      index = _ref.index,
      _ref$icons = _ref.icons,
      icons = _ref$icons === undefined ? {
    expanded: _react2.default.createElement('i', { className: 'mi mi-keyboard-arrow-down' }),
    collapsed: _react2.default.createElement('i', { className: 'mi mi-keyboard-arrow-right' }),
    blank: null
  } : _ref$icons,
      _ref$isFolder = _ref.isFolder,
      isFolder = _ref$isFolder === undefined ? function (node) {
    return !!node.children;
  } : _ref$isFolder;

  var _getNodeRenderOptions = (0, _nodes.getNodeRenderOptions)(node),
      isExpanded = _getNodeRenderOptions.isExpanded;

  var hasChildren = isFolder(node);

  var icon = null;
  if (hasChildren && isExpanded) {
    icon = icons.expanded;
  } else if (hasChildren && !isExpanded) {
    icon = icons.collapsed;
  } else {
    icon = icons.blank;
  }

  var handleChange = function handleChange() {
    onChange(_extends({}, (0, _nodes.updateNode)(node, { expanded: !isExpanded }), { index: index }));
  };

  return _react2.default.createElement(
    'span',
    { className: 'tree-expandable', onDoubleClick: handleChange, onClick: handleChange },
    hasChildren && _react2.default.createElement(
      'span',
      { className: 'tree-expandable-icon' },
      _react2.default.createElement(
        'span',
        { tabIndex: 0 },
        icon
      )
    ),
    _react2.default.createElement(
      'span',
      { className: 'tree-expandable-info' },
      children
    )
  );
};

Expandable.propTypes = process.env.NODE_ENV !== "production" ? _extends({}, _rendererShapes.Renderer, {
  iconsClassNameMap: _propTypes2.default.shape({
    expanded: _propTypes2.default.string,
    collapsed: _propTypes2.default.string,
    lastChild: _propTypes2.default.string
  })
}) : {};

exports.default = Expandable;
module.exports = exports['default'];